//
// ScreensaverPlugin.cpp
// tmp
//
// Created by Bob Polis at 2020-10-26
// Copyright (c) 2020 SwiftCoder. All rights reserved.
//

#include "ScreensaverPlugin.hpp"

void ScreensaverPlugin::setup(cairo_t* context, const cairo_rectangle_t& rect) {
    _c = context;
    _r = rect;
    make_black();
}

int ScreensaverPlugin::fps() const {
    return 30;
}

void ScreensaverPlugin::make_black() {
    cairo_set_source_rgb(_c, 0, 0, 0);
    cairo_rectangle(_c, 0, 0, _r.width, _r.height);
    cairo_fill(_c);
}

cairo_rectangle_t ScreensaverPlugin::random_rect() {
    return random_rect_in_rect(_r);
}

cairo_rectangle_t ScreensaverPlugin::random_rect_in_rect(const cairo_rectangle_t& rect) {
    cairo_rectangle_t r;
    std::uniform_real_distribution<double> dx {rect.x, rect.width};
    std::uniform_real_distribution<double> dy {rect.y, rect.height};
    double v1, v2;
    v1 = dx(_eng);
    v2 = dx(_eng);
    if (v1 < v2) {
        r.x = v1;
        r.width = v2 - v1;
    } else {
        r.x = v2;
        r.width = v1 - v2;
    }
    v1 = dy(_eng);
    v2 = dy(_eng);
    if (v1 < v2) {
        r.y = v1;
        r.height = v2 - v1;
    } else {
        r.y = v2;
        r.height = v1 - v2;
    }
    return r;
}

double ScreensaverPlugin::random_x() {
    std::uniform_real_distribution<double> dist {0, _r.width};
    return dist(_eng);
}

double ScreensaverPlugin::random_y() {
    std::uniform_real_distribution<double> dist {0, _r.height};
    return dist(_eng);
}

double ScreensaverPlugin::random01() {
    std::uniform_real_distribution<double> dist {};
    return dist(_eng);
}

double ScreensaverPlugin::random_between(double v1, double v2) {
    std::uniform_real_distribution<double> dist {v1, v2};
    return dist(_eng);
}
